#include "PE_Patch.h"


/*------------------------main---------------------------------------*/
int main(int argc, char *argv[])
{
    OFSTRUCT OffStruc;
    
    for (int i=1; i<argc; i++)    
    {
        /*   */
        int hFile = OpenFile(argv[i], &OffStruc, OF_READWRITE);
        /*       ,     . */        
        if (hFile == HFILE_ERROR)       
        {
                
            Message(argv[i]," can't be open");
            if (i < argc -1)
            continue;
            else
            return EXIT_SUCCESS;
        }
        /*   mapping */    
        void* hFileMap = CreateFileMapping((void*)hFile, NULL, PAGE_READWRITE, 0, 0, 0);
        /*       ,     . */
        if (hFileMap == NULL)
        {
            Message (argv[i]," Can't create file mapping object");
            if (i < argc -1)
            continue;
            else
            {
            CloseHandle ((void*) hFile);
            return EXIT_SUCCESS;
            }         
        }        
        /*     */
        void* pMapView = MapViewOfFile(hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        /*       ,     . */
        if (pMapView == NULL)
        {
            Message (argv[i]," Can't create map view of file");
            if (i < argc -1)
            continue;
            else
            {
            CloseHandle(hFileMap);
            CloseHandle((void*)hFile);
            return EXIT_SUCCESS;
            }
        }
        /*  ,        */
        if (!(PE_Patch (pMapView, hFile)))
        {
            Message(argv[i], " Can't patch this file");
            if (i < argc -1)
            continue;
            else            
            goto exit;
        }
        else
            MessageBox (NULL, "Sucsesfull", "PE_Patch", MB_OK); 
        
        exit:        
        /*    */
        UnmapViewOfFile (pMapView);    
        /*  mapping  */     
        CloseHandle(hFileMap);        
        /*   */       
        CloseHandle((void*)hFile);
    }    
    
    free (mem);  
         
    return EXIT_SUCCESS;
}
/*-------------------------------------------------------------------*/

/*------------------------Message-----------------------------------*/
void Message (char* FilePath, char* message) 
{
    
    char* strFile = FilePath;
    PathFindFileName (strFile);         
    MessageBox (NULL, strcat(strFile, message), "Error", MB_OK);     
}
/*-------------------------------------------------------------------*/



/*-------------------------PE_Patch------------------------------*/
bool PE_Patch (void* pMap, int hFile)
{
     IMAGE_DOS_HEADER* Tidh = (IMAGE_DOS_HEADER*)pMap;
     
     if (Tidh->e_magic != IMAGE_DOS_SIGNATURE) /*    */
         return FALSE;
     else
     {
         IMAGE_NT_HEADERS* Tinh = (IMAGE_NT_HEADERS*)(Tidh->e_lfanew + (int) pMap);        
         
         if (Tinh->Signature != IMAGE_NT_SIGNATURE) /*    */
             return FALSE;
         else
         {
                
                 if (!(PatchFile(Tinh, hFile, pMap))) /*   */
                     return FALSE;
 
         }
                   
     }    
     
     return TRUE;
}

/*---------------------------------------------------------------*/


/*----------------------------PatchFile---------------------------*/
bool PatchFile (IMAGE_NT_HEADERS* ImNtH, int hFile, void* pMap)
{
     int bytesWriten;
          
      int pEnter_old = ImNtH->OptionalHeader.AddressOfEntryPoint + ImNtH->OptionalHeader.ImageBase; 
     /*     */
     IMAGE_SECTION_HEADER* pImSec_new =  (IMAGE_SECTION_HEADER*)(sizeof (IMAGE_NT_HEADERS) + (int)ImNtH); 

     /*    */
     memcpy(TInsert.chInsert1, cInsert1, sizeof(cInsert1));
     int pDllName = (int) (pImSec_new->Misc.VirtualSize + pImSec_new->VirtualAddress + sizeof(INSERT)-sizeof(TInsert.NameDll)+ ImNtH->OptionalHeader.ImageBase);
     memcpy(TInsert.pNameDll, &pDllName, 4); 
     memcpy(TInsert.chInsert2, cInsert2, sizeof(cInsert2));     
     memcpy(&TInsert.pEntryPoint, &pEnter_old, sizeof(TInsert.pEntryPoint));
     memcpy(TInsert.chInsert3, cInsert3, sizeof(cInsert3));
     memcpy(TInsert.NameDll, DllName, strlen(DllName));
     /*       */
     memcpy((void*)((int)pImSec_new->Misc.VirtualSize + (int)pImSec_new->PointerToRawData+(int)pMap), &TInsert, sizeof(TInsert));
     /*  entry point */
     ImNtH->OptionalHeader.AddressOfEntryPoint = pImSec_new->Misc.VirtualSize + pImSec_new->VirtualAddress;     
    /*    */
     pImSec_new->Misc.VirtualSize += sizeof(TInsert);      
     
         
     return TRUE;
}




